var VOLUME_STEP = 5;
var DECREASE_STEP_VALUE_ON = 3; /*on which repeated step we reduce VOLUME_STEP*/
var SONOS_PORT = 1400; 

var lInfo = {logln:function (o){}};

var LOGFILE_NAME = "sonos-controller.log";
lInfo = new Logger(LOGFILE_NAME);

function storeSubParameter(root, path, value) {
  Property.setProperty(root +'/' + path, value);
  Property.setFlag(root + '/' + path, 'ARCHIVE', true);
  lInfo.logln("STORING " + root + "/" + path + " -> " + value);
}

function upnpParseXMLRespond(szXMLRespond, szXMLFieldName, szContainsText) {
    //lInfo.logln(szXMLRespond);
    var searched_value = '';
    var found = 0;
    var xml_text = '';
    var start_pos = 0;
    
    xml_text = szXMLRespond;
    
    do
    {        
        start_pos = xml_text.indexOf('<' + szXMLFieldName);
        
        if (start_pos == -1)
        {
            break;
        }
        
        start_pos += szXMLFieldName.length + 1;
        start_pos += 1 /* skip '>' */;
        
        var end_pos = xml_text.indexOf('</' + szXMLFieldName);
        
        if (end_pos == -1)
        {
            break;
        };
            
        searched_value = xml_text.substring(start_pos, end_pos);
        
        if (szContainsText != "")
        {
            if (searched_value.indexOf(szContainsText) == -1)
            {
                start_pos = end_pos + szXMLFieldName.length + 1;
                xml_text = xml_text.substring(start_pos, xml_text.length);
                
                lInfo.logln("Filter not match, continue search: : " + xml_text);                
            }
            else
            {
                found = 1;
            }
        }
        else
        {
            found = 1;
        }
    }
    while ((szContainsText != "") && (found == 0) && (xml_text != ""))
    
    return searched_value;
}

function upnpSetVolume(szIpAddressRenderer, nVolume, oCurlOptions) {
  try {
    var http_headers = [];
    http_headers[''] = 'Content-Type: text/xml; charset="utf-8"';
    http_headers[''] = 'SOAPACTION: "urn:schemas-upnp-org:service:RenderingControl:1#SetVolume"';

    var h = new HTTP(oCurlOptions, http_headers);
    h.reset();
                           
    var url = 'http://' + szIpAddressRenderer + ':' + SONOS_PORT + '/MediaRenderer/RenderingControl/Control';

    var action = '<?xml version="1.0" encoding="utf-8"?>' 
              + '<s:Envelope s:encodingStyle="http://schemas.xmlsoap.org/soap/encoding/" xmlns:s="http://schemas.xmlsoap.org/soap/envelope/">'
              + '<s:Body>'
                 + '<u:SetVolume xmlns:u="urn:schemas-upnp-org:service:RenderingControl:1">'
                 + '<InstanceID>0</InstanceID>'
                 + '<Channel>Master</Channel>'
                 + '<DesiredVolume>'+nVolume+'</DesiredVolume>'
                 + '</u:SetVolume>'
              + '</s:Body>'
              + '</s:Envelope>';
 
    //h.post(url, '', action, function (){});//function (sValue){lInfo.logln("\\"+sValue+"\\");}
    h.post(url, '', action);//function (sValue){lInfo.logln("\\"+sValue+"\\");}
  }
  catch (e) {
      lInfo.logln("Error executing upnpSetVolume command " + e);
  }
}

function upnpGetVolume(szIpAddressRenderer, oCurlOptions) {
  try {
    var http_headers = [];
    http_headers[''] = 'Content-Type: text/xml; charset="utf-8"';
    http_headers[''] = 'SOAPACTION: "urn:schemas-upnp-org:service:RenderingControl:1#GetVolume"';//

    var h = new HTTP({'debug' : 0}, http_headers);//{'debug' : 0}
    
    h.reset();
    var url = 'http://'+ szIpAddressRenderer + ':' + SONOS_PORT + '/MediaRenderer/RenderingControl/Control';
   
    var action = '<?xml version="1.0" encoding="utf-8"?>' 
              + '<s:Envelope s:encodingStyle="http://schemas.xmlsoap.org/soap/encoding/" xmlns:s="http://schemas.xmlsoap.org/soap/envelope/">'
              + '<s:Body>'
                 + '<u:GetVolume xmlns:u="urn:schemas-upnp-org:service:RenderingControl:1">'
                 + '<InstanceID>0</InstanceID>'
                 + '<Channel>Master</Channel>'
                 + '</u:GetVolume>'
              + '</s:Body>'
              + '</s:Envelope>'; 
    var result = h.post(url, '', action);
    
    if (result != null && result.body != null) {
      return upnpParseXMLRespond(result.body, 'CurrentVolume', '')
    }
    else
      return null;
  } catch (e) {
    lInfo.logln("Error executing upnpGetVolume command " + e);
  }
  return null;
}

var nTime = 0;
try {
  nTime = new Date().getTime();
}
catch (e)
{
  lWarn.logln("Exception by getting current time");
} 

/*
lInfo.logln("!VOLUME ONLY!"+startA);
lInfo.logln("sceneID: ", raisedEvent.parameter.sceneID);
lInfo.logln("groupID: ", raisedEvent.parameter.groupID);
  */
lInfo.logln(JSON.stringify(raisedEvent)); 
var nSceneID =  parseInt("" + raisedEvent.parameter.sceneID, 10);
var bSkipStep = false;

var sPlayerIP = "";
var sRoomID = "";
var sGroupedSlavesIP = "";
var execPreset = Property.getNode(raisedEvent.parameter.path);
var nStoredStep = 0;
var nStoredStepValue = VOLUME_STEP;
var nStoredLastTime = 0;

if (execPreset != null){
  var nZoneID =  parseInt("" + execPreset.getChild('roomID').getValue(), 10);
  var baseNode = Property.getNode('sonos-players');
  if (baseNode != null) {
    var oArrayNode = baseNode.getChildren();
    for ( var iIndex = 0; iIndex < oArrayNode.length; iIndex++) {
      var oChildNode = oArrayNode[iIndex];
      if (!JSON.parse(oChildNode.getChild('disabled').getValue())) {
        if (nZoneID == parseInt("" + oChildNode.getChild('roomID').getValue(),10)) {
          sPlayerIP = oChildNode.getChild('ipAddress').getValue();
          sGroupedSlavesIP = oChildNode.getChild('playersListIPSlaves').getValue();
          sRoomID = oChildNode.getChild('roomID').getValue();
          
          var dimmValue = Property.getNode("dimming");
          var sPath = nSceneID+"-"+sRoomID;
          
          if (dimmValue != null && dimmValue.getChild(sPath) != null) {
            nStoredStep = parseInt(""+dimmValue.getChild(sPath).getValue());
            if (dimmValue.getChild(sPath+"-step") != null)
              nStoredStepValue = parseInt(""+dimmValue.getChild(sPath+"-step").getValue());
            if (dimmValue.getChild(sPath+"-time") != null)
              nStoredLastTime = parseInt(""+dimmValue.getChild(sPath+"-time").getValue());
            
            // if last record volume change is more than 5 seconds we reset values     
            if (nTime != null && nTime - nStoredLastTime > 5000) { 
              nStoredStep = 0;
              nStoredStepValue = VOLUME_STEP;   
              lInfo.logln("Reset volume values"); 
            }
          }

          /* single skip test
          if (dimmValue != null && dimmValue.getChild(sRoomID) != null) {
            dimmValue.removeChild(sRoomID);
            bSkipStep = true;
          }
          else {
            storeSubParameter('dimming', sRoomID, 1);
          } */
          break;
        }
      }
    }
  }
}

var bStoreValues = (nStoredStep == 0);
if (nStoredStep > 0 && (nStoredStep % DECREASE_STEP_VALUE_ON == 0) && nStoredStepValue > 1) {
  nStoredStepValue = nStoredStepValue - 1; 
  bStoreValues = true;
}

lInfo.logln("EXEC STEP="+nStoredStep); 
lInfo.logln("nStoredStepValue="+nStoredStepValue);
 
 var nClearOtherScene = "";
 if (nSceneID == 11)
   nClearOtherScene = 12;
 else
   nClearOtherScene = 11;

 nStoredStep = nStoredStep + 1;
 
 var sPath = nSceneID+"-"+sRoomID;
 var sPathOther = nClearOtherScene+"-"+sRoomID;
 
 storeSubParameter('dimming', sPath, nStoredStep);
 storeSubParameter('dimming', sPath+"-time", nTime);
 if (bStoreValues) {
   storeSubParameter('dimming', sPath+"-step", nStoredStepValue);

   storeSubParameter('dimming', sPathOther, 0);
   storeSubParameter('dimming', sPathOther+"-step", VOLUME_STEP);
   storeSubParameter('dimming', sPathOther+"-time", 0);
 }

  if (sPlayerIP.length > 0) {
    var curl_options = new Object({'debug' : 1, 'connectTimeout' : 200}); 
    var currentVolume = upnpGetVolume(sPlayerIP, curl_options);
    //var currentVolume = Math.floor((Math.random()*30)+1);
    if (currentVolume != null) 
    {
      var nVolume = parseInt("" + currentVolume,10);
      //lInfo.logln("PLAYER VOLUME : ", nVolume);

      var bChangeVolume = true;
      if (nSceneID == 11) {
        if (nVolume < 1)
           bChangeVolume = false;
         nVolume = nVolume - nStoredStepValue;
         if (nVolume < 0)
           nVolume = 0;
      }
      else if (nSceneID == 12) {
        if (nVolume > 99)
          bChangeVolume = false;
        nVolume = nVolume + nStoredStepValue;
        if (nVolume > 100)
          nVolume = 100;
      } 
    
      if (bChangeVolume) {
  //      lInfo.logln("NEW VOLUME SET : ", nVolume);
        upnpSetVolume(sPlayerIP, nVolume, curl_options);

        var aSlaves = null;
        if (sGroupedSlavesIP.length > 0) {
          aSlaves = sGroupedSlavesIP.split(","); 
          // send volume comand to all slaves players if grouped 
          if (aSlaves != null && aSlaves.length > 0) {
            for (var iIndex=0;iIndex<aSlaves.length;iIndex++) {
              var sSlaveIP = aSlaves[iIndex].trim();
              var currentVolume = upnpGetVolume(sSlaveIP, curl_options);
              if (currentVolume != null) {
                var nVolume = parseInt("" + currentVolume,10);

                var bChangeVolume = true;
                if (nSceneID == 11) {
                  if (nVolume < 1)
                     bChangeVolume = false;
                   nVolume = nVolume - nStoredStepValue;
                   if (nVolume < 0)
                     nVolume = 0;
                }
                else if (nSceneID == 12) {
                  if (nVolume > 99)
                    bChangeVolume = false;
                  nVolume = nVolume + nStoredStepValue;
                  if (nVolume > 100)
                    nVolume = 100;
                } 
                
                if(bChangeVolume) {
                  lInfo.logln("Set slave volume for "+sSlaveIP);
                  upnpSetVolume(sSlaveIP, nVolume, curl_options);
                }
              }
            }
          }
        }
      }
    }
  }


